libstdc++: std::basic_stringbuf< _CharT, _Traits, _Alloc > Class Template Reference

libstdc++

std::basic_stringbuf< _CharT, _Traits, _Alloc > Class Template Reference
I/O

`#include <sstream>`

Inheritance diagram for std::basic_stringbuf< _CharT, _Traits, _Alloc >:
[legend]

## Public Types
typedef __string_type::size_type | __size_type
typedef basic_streambuf< char_type, traits_type > | __streambuf_type
typedef basic_string< char_type, _Traits, _Alloc > | __string_type
typedef _Alloc | allocator_type
typedef _CharT | char_type
typedef traits_type::int_type | int_type
typedef traits_type::off_type | off_type
typedef traits_type::pos_type | pos_type
typedef _Traits | traits_type

## Public Member Functions
| basic_stringbuf ()
| basic_stringbuf (__string_type &&__s, ios_base::openmode __mode=ios_base::in|ios_base::out)
| basic_stringbuf (basic_stringbuf &&__rhs)
| basic_stringbuf (basic_stringbuf &&__rhs, const allocator_type &__a)
| basic_stringbuf (const __string_type &__str, ios_base::openmode __mode=ios_base::in|ios_base::out)
| basic_stringbuf (const allocator_type &__a)
template<typename _SAlloc>
| basic_stringbuf (const basic_string< _CharT, _Traits, _SAlloc > &__s, const allocator_type &__a)
template<typename _SAlloc>
| basic_stringbuf (const basic_string< _CharT, _Traits, _SAlloc > &__s, ios_base::openmode __mode, const allocator_type &__a)
template<typename _SAlloc>
| basic_stringbuf (const basic_string< _CharT, _Traits, _SAlloc > &__s, ios_base::openmode __mode=ios_base::in|ios_base::out)
| basic_stringbuf (const basic_stringbuf &)=delete
| basic_stringbuf (ios_base::openmode __mode)
| basic_stringbuf (ios_base::openmode __mode, const allocator_type &__a)
allocator_type | get_allocator () const noexcept
locale | getloc () const
streamsize | in_avail ()
basic_stringbuf & | operator= (basic_stringbuf &&__rhs)
basic_stringbuf & | operator= (const basic_stringbuf &)=delete
locale | pubimbue (const locale &__loc)
int_type | sbumpc ()
int_type | sgetc ()
streamsize | sgetn (char_type *__s, streamsize __n)
int_type | snextc ()
int_type | sputbackc (char_type __c)
int_type | sputc (char_type __c)
streamsize | sputn (const char_type *__s, streamsize __n)
__string_type | str () &&
__string_type | str () const &
void | str (__string_type &&__s)
void | str (const __string_type &__s)
template<__allocator_like _SAlloc>
basic_string< _CharT, _Traits, _SAlloc > | str (const _SAlloc &__sa) const
template<__allocator_like _SAlloc>
void | str (const basic_string< _CharT, _Traits, _SAlloc > &__s)
int_type | sungetc ()
void | swap (basic_stringbuf &__rhs) noexcept(_Noexcept_swap::value)
basic_string_view< char_type, traits_type > | view () const noexcept
basic_streambuf * | pubsetbuf (char_type *__s, streamsize __n)
pos_type | pubseekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
pos_type | pubseekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
int | pubsync ()

## Protected Member Functions
void | __safe_gbump (streamsize __n)
void | __safe_pbump (streamsize __n)
void | _M_pbump (char_type *__pbeg, char_type *__pend, off_type __off)
void | _M_stringbuf_init (ios_base::openmode __mode)
void | _M_sync (char_type *__base, __size_type __i, __size_type __o)
void | _M_update_egptr ()
void | gbump (int __n)
virtual void | imbue (const locale &__loc)
virtual int_type | overflow (int_type __c=traits_type::eof())
virtual int_type | pbackfail (int_type __c=traits_type::eof())
void | pbump (int __n)
virtual pos_type | seekoff (off_type __off, ios_base::seekdir __way, ios_base::openmode __mode=ios_base::in|ios_base::out)
virtual pos_type | seekpos (pos_type __sp, ios_base::openmode __mode=ios_base::in|ios_base::out)
virtual __streambuf_type * | setbuf (char_type *__s, streamsize __n)
void | setg (char_type *__gbeg, char_type *__gnext, char_type *__gend)
void | setp (char_type *__pbeg, char_type *__pend)
virtual streamsize | showmanyc ()
void | swap (basic_streambuf &__sb)
virtual int | sync ()
virtual int_type | uflow ()
virtual int_type | underflow ()
virtual streamsize | xsgetn (char_type *__s, streamsize __n)
virtual streamsize | xsputn (const char_type *__s, streamsize __n)
char_type * | eback () const
char_type * | gptr () const
char_type * | egptr () const
char_type * | pbase () const
char_type * | pptr () const
char_type * | epptr () const

## Protected Attributes
locale | _M_buf_locale
char_type * | _M_in_beg
char_type * | _M_in_cur
char_type * | _M_in_end
ios_base::openmode | _M_mode
char_type * | _M_out_beg
char_type * | _M_out_cur
char_type * | _M_out_end
__string_type | _M_string

## Detailed Description

template<typename _CharT, typename _Traits, typename _Alloc>
class std::basic_stringbuf< _CharT, _Traits, _Alloc >

The actual work of input and output (for std::string).

Template Parameters

  _CharT | Type of character stream.
  _Traits | Traits for character type, defaults to char_traits<_CharT>.
  _Alloc | Allocator type, defaults to allocator<_CharT>.

This class associates either or both of its input and output sequences with a sequence of characters, which can be initialized from, or made available as, a `std::basic_string`. (Paraphrased from [27.7.1]/1.)

For this class, open modes (of type `ios_base::openmode`) have `in` set if the input sequence can be read, and `out` set if the output sequence can be written.

Definition at line 87 of file sstream.

## Member Typedef Documentation

## ◆ __size_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef __string_type::size_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::__size_type

Definition at line 110 of file sstream.

## ◆ __streambuf_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef basic_streambuf<char_type, traits_type> std::basic_stringbuf< _CharT, _Traits, _Alloc >::__streambuf_type

Definition at line 108 of file sstream.

## ◆ __string_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef basic_string<char_type, _Traits, _Alloc> std::basic_stringbuf< _CharT, _Traits, _Alloc >::__string_type

Definition at line 109 of file sstream.

## ◆ allocator_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Alloc std::basic_stringbuf< _CharT, _Traits, _Alloc >::allocator_type

Definition at line 103 of file sstream.

## ◆ char_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _CharT std::basic_stringbuf< _CharT, _Traits, _Alloc >::char_type

Definition at line 99 of file sstream.

## ◆ int_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef traits_type::int_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::int_type

Definition at line 104 of file sstream.

## ◆ off_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef traits_type::off_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::off_type

Definition at line 106 of file sstream.

## ◆ pos_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef traits_type::pos_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::pos_type

Definition at line 105 of file sstream.

## ◆ traits_type

template<typename _CharT, typename _Traits, typename _Alloc>

typedef _Traits std::basic_stringbuf< _CharT, _Traits, _Alloc >::traits_type

Definition at line 100 of file sstream.

## Constructor & Destructor Documentation

## ◆ basic_stringbuf() [1/11]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( |  | ) |
| inline

Starts with an empty string buffer.

The default constructor initializes the parent class using its own default ctor.

Definition at line 128 of file sstream.

## ◆ basic_stringbuf() [2/11]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | ios_base::openmode | __mode | ) |
| inlineexplicit

Starts with an empty string buffer.

Parameters

  __mode | Whether the buffer can read, or write, or both.

The default constructor initializes the parent class using its own default ctor.

Definition at line 140 of file sstream.

## ◆ basic_stringbuf() [3/11]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | const __string_type & | __str,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineexplicit

Starts with an existing string buffer.

Parameters

  __str | A string to copy as a starting buffer.
  __mode | Whether the buffer can read, or write, or both.

This constructor initializes the parent class using its own default ctor.

Definition at line 153 of file sstream.

## ◆ basic_stringbuf() [4/11]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | basic_stringbuf< _CharT, _Traits, _Alloc > && | __rhs | ) |
| inline

Definition at line 162 of file sstream.

## ◆ basic_stringbuf() [5/11]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | const allocator_type & | __a | ) |
| inlineexplicit

Definition at line 169 of file sstream.

## ◆ basic_stringbuf() [6/11]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | ios_base::openmode | __mode,
|  | const allocator_type & | __a )
| inline

Definition at line 173 of file sstream.

## ◆ basic_stringbuf() [7/11]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | __string_type && | __s,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineexplicit

Definition at line 179 of file sstream.

## ◆ basic_stringbuf() [8/11]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _SAlloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | const basic_string< _CharT, _Traits, _SAlloc > & | __s,
|  | const allocator_type & | __a )
| inline

Definition at line 186 of file sstream.

## ◆ basic_stringbuf() [9/11]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _SAlloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | const basic_string< _CharT, _Traits, _SAlloc > & | __s,
|  | ios_base::openmode | __mode,
|  | const allocator_type & | __a )
| inline

Definition at line 192 of file sstream.

## ◆ basic_stringbuf() [10/11]

template<typename _CharT, typename _Traits, typename _Alloc>
template<typename _SAlloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | const basic_string< _CharT, _Traits, _SAlloc > & | __s,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineexplicit

Definition at line 201 of file sstream.

## ◆ basic_stringbuf() [11/11]

template<typename _CharT, typename _Traits, typename _Alloc>

std::basic_stringbuf< _CharT, _Traits, _Alloc >::basic_stringbuf | ( | basic_stringbuf< _CharT, _Traits, _Alloc > && | __rhs,
|  | const allocator_type & | __a )
| inline

Definition at line 236 of file sstream.

## Member Function Documentation

## ◆ __safe_gbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::__safe_gbump | ( | streamsize | __n | ) |
| inlineprotectedinherited

Definition at line 804 of file streambuf.

## ◆ __safe_pbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::__safe_pbump | ( | streamsize | __n | ) |
| inlineprotectedinherited

Definition at line 807 of file streambuf.

## ◆ _M_pbump()

template<class _CharT, class _Traits, class _Alloc>

void std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_pbump | ( | char_type * | __pbeg,
|  | char_type * | __pend,
|  | off_type | __off )
| protected

Definition at line 280 of file sstream.tcc.

## ◆ _M_stringbuf_init()

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_stringbuf_init | ( | ios_base::openmode | __mode | ) |
| inlineprotected

Definition at line 394 of file sstream.

## ◆ _M_sync()

template<class _CharT, class _Traits, class _Alloc>

void std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_sync | ( | char_type * | __base,
|  | __size_type | __i,
|  | __size_type | __o )
| protected

Definition at line 249 of file sstream.tcc.

## ◆ _M_update_egptr()

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_update_egptr | ( |  | ) |
| inlineprotected

Definition at line 471 of file sstream.

## ◆ eback()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::eback | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 491 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_filebuf< _CharT, _Traits >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## ◆ egptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::egptr | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 497 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_streambuf< char_type, traits_type >::in_avail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sgetc(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::wbuffer_convert< _Codecvt, _Elem, _Tr >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and xsgetn().

## ◆ epptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::epptr | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 544 of file streambuf.

Referenced by std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_streambuf< char_type, traits_type >::sputc(), std::basic_filebuf< _CharT, _Traits >::xsputn(), and xsputn().

## ◆ gbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::gbump | ( | int | __n | ) |
| inlineprotectedinherited

Moving the read position.

Parameters

  __n | The delta by which to move.

This just advances the read position without returning any data.

Definition at line 507 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_streambuf< char_type, traits_type >::uflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## ◆ get_allocator()

template<typename _CharT, typename _Traits, typename _Alloc>

allocator_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::get_allocator | ( |  | ) | const
| inlinenoexcept

Definition at line 240 of file sstream.

## ◆ getloc()

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::getloc | ( |  | ) | const
| inlineinherited

Locale access.

Returns
  The current locale in effect.

If pubimbue(loc) has been called, then the most recent `loc` is returned. Otherwise the global locale in effect at the time of construction is returned.

Definition at line 235 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubimbue().

## ◆ gptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::gptr | ( |  | ) | const
| inlineprotectedinherited

Access to the get area.

These functions are only available to other protected functions, including derived classes.

- eback() returns the beginning pointer for the input sequence
- gptr() returns the next pointer for the input sequence
- egptr() returns the end pointer for the input sequence

Definition at line 494 of file streambuf.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_streambuf< char_type, traits_type >::in_avail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::sbumpc(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_streambuf< char_type, traits_type >::sgetc(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_streambuf< char_type, traits_type >::sputbackc(), std::basic_streambuf< char_type, traits_type >::sungetc(), std::basic_streambuf< char_type, traits_type >::uflow(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), std::wbuffer_convert< _Codecvt, _Elem, _Tr >::underflow(), std::basic_filebuf< _CharT, _Traits >::xsgetn(), and xsgetn().

## ◆ imbue()

template<typename _CharT, typename _Traits>

virtual void std::basic_streambuf< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) |
| inlineprotectedvirtualinherited

Changes translations.

Parameters

  __loc | A new locale.

Translations done during I/O which depend on the current locale are changed by this call. The standard adds, Between invocations of this function a class derived from streambuf can safely cache results of calls to locale functions and to members of facets so obtained.

Note
  Base class version does nothing.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, std::basic_filebuf< char_type, traits_type >, and std::basic_filebuf< wchar_t >.

Definition at line 585 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubimbue().

## ◆ in_avail()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::in_avail | ( |  | ) |
| inlineinherited

Looking ahead into the stream.

Returns
  The number of characters available.

If a read position is available, returns the number of characters available for reading before the buffer must be refilled. Otherwise returns the derived `showmanyc()`.

Definition at line 293 of file streambuf.

## ◆ operator=()

template<typename _CharT, typename _Traits, typename _Alloc>

basic_stringbuf & std::basic_stringbuf< _CharT, _Traits, _Alloc >::operator= | ( | basic_stringbuf< _CharT, _Traits, _Alloc > && | __rhs | ) |
| inline

Definition at line 250 of file sstream.

## ◆ overflow()

template<class _CharT, class _Traits, class _Alloc>

basic_stringbuf< _CharT, _Traits, _Alloc >::int_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow | ( | int_type | __c = traits_type::eof() | ) |
| protectedvirtual

Consumes data from the buffer; writes to the controlled sequence.

Parameters

  __c | An additional character to consume.

Returns
  eof() to indicate failure, something else (usually __c, or not_eof())

Informally, this function is called when the output buffer is full (or does not exist, as buffering need not actually be done). If a buffer exists, it is consumed, with some effect on the controlled sequence. (Typically, the buffer is written out to the sequence verbatim.) In either case, the character c is also written out, if __c is not `eof()`.

For a formal definition of this function, see a good text such as Langer & Kreft, or [27.5.2.4.5]/3-7.

A functioning output streambuf can be created by overriding only this function (no buffer area will be used).

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 83 of file sstream.tcc.

References _M_mode, std::basic_string< _CharT, _Traits, _Alloc >::assign(), std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::epptr(), std::basic_streambuf< _CharT, _Traits >::gptr(), std::ios_base::in, std::max(), std::min(), std::ios_base::out, std::basic_streambuf< _CharT, _Traits >::pbase(), std::basic_streambuf< _CharT, _Traits >::pbump(), std::basic_streambuf< _CharT, _Traits >::pptr(), std::basic_string< _CharT, _Traits, _Alloc >::push_back(), std::basic_string< _CharT, _Traits, _Alloc >::reserve(), and std::basic_streambuf< _CharT, _Traits >::setg().

## ◆ pbackfail()

template<class _CharT, class _Traits, class _Alloc>

basic_stringbuf< _CharT, _Traits, _Alloc >::int_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail | ( | int_type | __c = traits_type::eof() | ) |
| protectedvirtual

Tries to back up the input sequence.

Parameters

  __c | The character to be inserted back into the sequence.

Returns
  eof() on failure, some other value on success

Postcondition
  The constraints of `gptr()`, `eback()`, and `pptr()` are the same as for `underflow()`.

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 49 of file sstream.tcc.

References _M_mode, std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::gbump(), std::basic_streambuf< _CharT, _Traits >::gptr(), and std::ios_base::out.

## ◆ pbase()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::pbase | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 538 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::str(), std::basic_filebuf< _CharT, _Traits >::sync(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## ◆ pbump()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::pbump | ( | int | __n | ) |
| inlineprotectedinherited

Moving the write position.

Parameters

  __n | The delta by which to move.

This just advances the write position without returning any data.

Definition at line 554 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), and std::basic_streambuf< char_type, traits_type >::sputc().

## ◆ pptr()

template<typename _CharT, typename _Traits>

char_type * std::basic_streambuf< _CharT, _Traits >::pptr | ( |  | ) | const
| inlineprotectedinherited

Access to the put area.

These functions are only available to other protected functions, including derived classes.

- pbase() returns the beginning pointer for the output sequence
- pptr() returns the next pointer for the output sequence
- epptr() returns the end pointer for the output sequence

Definition at line 541 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_streambuf< char_type, traits_type >::sputc(), std::basic_filebuf< _CharT, _Traits >::sync(), std::basic_filebuf< _CharT, _Traits >::xsputn(), and xsputn().

## ◆ pubimbue()

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::pubimbue | ( | const locale & | __loc | ) |
| inlineinherited

Entry point for imbue().

Parameters

  __loc | The new locale.

Returns
  The previous locale.

Calls the derived imbue(__loc).

Definition at line 218 of file streambuf.

## ◆ pubseekoff()

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekoff | ( | off_type | __off,
|  | ios_base::seekdir | __way,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineinherited

Alters the stream position.

Parameters

  __off | Offset.
  __way | Value for ios_base::seekdir.
  __mode | Value for ios_base::openmode.

Calls virtual seekoff function.

Definition at line 260 of file streambuf.

## ◆ pubseekpos()

template<typename _CharT, typename _Traits>

pos_type std::basic_streambuf< _CharT, _Traits >::pubseekpos | ( | pos_type | __sp,
|  | ios_base::openmode | __mode = ios_base::in | ios_base::out )
| inlineinherited

Alters the stream position.

Parameters

  __sp | Position
  __mode | Value for ios_base::openmode.

Calls virtual seekpos function.

Definition at line 272 of file streambuf.

## ◆ pubsetbuf()

template<typename _CharT, typename _Traits>

basic_streambuf * std::basic_streambuf< _CharT, _Traits >::pubsetbuf | ( | char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry points for derived buffer functions.

The public versions of `pubfoo` dispatch to the protected derived `foo` member functions, passing the arguments (if any) and returning the result unchanged.

Definition at line 248 of file streambuf.

## ◆ pubsync()

template<typename _CharT, typename _Traits>

int std::basic_streambuf< _CharT, _Traits >::pubsync | ( |  | ) |
| inlineinherited

Calls virtual sync function.

Definition at line 280 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::sync().

## ◆ sbumpc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sbumpc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

If the input read position is available, returns that character and increments the read pointer, otherwise calls and returns `uflow()`.

Definition at line 325 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::ignore(), std::basic_streambuf< char_type, traits_type >::snextc(), and std::basic_istream< _CharT, char_traits< _CharT > >::unget().

## ◆ seekoff()

template<class _CharT, class _Traits, class _Alloc>

basic_stringbuf< _CharT, _Traits, _Alloc >::pos_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff | ( | off_type | ,
|  | ios_base::seekdir | ,
|  | ios_base::openmode | = ios_base::in | ios_base::out )
| protectedvirtual

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 171 of file sstream.tcc.

References _M_mode, std::ios_base::cur, std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::egptr(), std::ios_base::end, std::basic_streambuf< _CharT, _Traits >::epptr(), std::basic_streambuf< _CharT, _Traits >::gptr(), std::ios_base::in, std::ios_base::out, std::basic_streambuf< _CharT, _Traits >::pbase(), std::basic_streambuf< _CharT, _Traits >::pptr(), and std::basic_streambuf< _CharT, _Traits >::setg().

## ◆ seekpos()

template<class _CharT, class _Traits, class _Alloc>

basic_stringbuf< _CharT, _Traits, _Alloc >::pos_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos | ( | pos_type | ,
|  | ios_base::openmode | = ios_base::in | ios_base::out )
| protectedvirtual

Alters the stream positions.

Each derived class provides its own appropriate behavior.

Note
  Base class version does nothing, returns a `pos_type` that represents an invalid stream position.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 219 of file sstream.tcc.

References _M_mode, std::basic_streambuf< _CharT, _Traits >::eback(), std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::epptr(), std::ios_base::in, std::ios_base::out, std::basic_streambuf< _CharT, _Traits >::pbase(), and std::basic_streambuf< _CharT, _Traits >::setg().

## ◆ setbuf()

template<typename _CharT, typename _Traits, typename _Alloc>

virtual __streambuf_type * std::basic_stringbuf< _CharT, _Traits, _Alloc >::setbuf | ( | char_type * | __s,
|  | streamsize | __n )
| inlineprotectedvirtual

Manipulates the buffer.

Parameters

  __s | Pointer to a buffer area.
  __n | Size of __s.

Returns
  `this`

If no buffer has already been created, and both __s and __n are non-zero, then `__s` is used as a buffer; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html#io.streambuf.buffering for more.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 436 of file sstream.

## ◆ setg()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setg | ( | char_type * | __gbeg,
|  | char_type * | __gnext,
|  | char_type * | __gend )
| inlineprotectedinherited

Setting the three read area pointers.

Parameters

  __gbeg | A pointer.
  __gnext | A pointer.
  __gend | A pointer.

Postcondition
  __gbeg == `eback()`, __gnext == `gptr()`, and __gend == `egptr()`

Definition at line 518 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::wbuffer_convert(), std::basic_filebuf< char_type, traits_type >::_M_create_pback(), std::basic_filebuf< char_type, traits_type >::_M_destroy_pback(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## ◆ setp()

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::setp | ( | char_type * | __pbeg,
|  | char_type * | __pend )
| inlineprotectedinherited

Setting the three write area pointers.

Parameters

  __pbeg | A pointer.
  __pend | A pointer.

Postcondition
  __pbeg == `pbase()`, __pbeg == `pptr()`, and __pend == `epptr()`

Definition at line 564 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::wbuffer_convert(), and std::basic_filebuf< char_type, traits_type >::_M_set_buffer().

## ◆ sgetc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sgetc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

If the input read position is available, returns that character, otherwise calls and returns `underflow()`. Does not move the read position after fetching the character.

Definition at line 347 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, char_traits< _CharT > >::readsome(), and std::basic_streambuf< char_type, traits_type >::snextc().

## ◆ sgetn()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sgetn | ( | char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry point for xsgetn.

Parameters

  __s | A buffer area.
  __n | A count.

Returns xsgetn(__s,__n). The effect is to fill __s[0] through __s[__n-1] with characters from the input sequence, if possible.

Definition at line 366 of file streambuf.

## ◆ showmanyc()

template<typename _CharT, typename _Traits, typename _Alloc>

virtual streamsize std::basic_stringbuf< _CharT, _Traits, _Alloc >::showmanyc | ( |  | ) |
| inlineprotectedvirtual

Investigating the data available.

Returns
  An estimate of the number of characters available in the input sequence, or -1.

If it returns a positive value, then successive calls to `underflow()` will not return `traits::eof()` until at least that number of characters have been supplied. If `showmanyc()` returns -1, then calls to `underflow()` or `uflow()` will fail. [27.5.2.4.3]/1

Note
  Base class version does nothing, returns zero.
  The standard adds that the intention is not only that the calls [to underflow or uflow] will not return `eof()` but that they will return immediately.
  The standard adds that the morphemes of `showmanyc` are es-how-many-see, not show-manic.

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 404 of file sstream.

## ◆ snextc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::snextc | ( |  | ) |
| inlineinherited

Getting the next character.

Returns
  The next character, or eof.

Calls `sbumpc()`, and if that function returns `traits::eof()`, so does this function. Otherwise, `sgetc()`.

Definition at line 307 of file streambuf.

Referenced by std::basic_istream< _CharT, char_traits< _CharT > >::get(), std::basic_iostream< char_type, traits_type >::ignore(), and std::basic_istream< _CharT, char_traits< _CharT > >::readsome().

## ◆ sputbackc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputbackc | ( | char_type | __c | ) |
| inlineinherited

Pushing characters back into the input stream.

Parameters

  __c | The character to push back.

Returns
  The previous character, if possible.

Similar to sungetc(), but __c is pushed onto the stream instead of the previous character. If successful, the next character fetched from the input stream will be __c.

Definition at line 381 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::putback().

## ◆ sputc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sputc | ( | char_type | __c | ) |
| inlineinherited

Entry point for all single-character output functions.

Parameters

  __c | A character to output.

Returns
  __c, if possible.

One of two public output functions.

If a write position is available for the output sequence (i.e., the buffer is not full), stores __c in that position, increments the position, and returns `traits::to_int_type(__c)`. If a write position is not available, returns `overflow(__c)`.

Definition at line 433 of file streambuf.

Referenced by std::wbuffer_convert< _Codecvt, _Elem, _Tr >::overflow().

## ◆ sputn()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::sputn | ( | const char_type * | __s,
|  | streamsize | __n )
| inlineinherited

Entry point for all single-character output functions.

Parameters

  __s | A buffer read area.
  __n | A count.

One of two public output functions.

Returns xsputn(__s,__n). The effect is to write __s[0] through __s[__n-1] to the output sequence, if possible.

Definition at line 459 of file streambuf.

## ◆ str() [1/6]

template<typename _CharT, typename _Traits, typename _Alloc>

__string_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::str | ( |  | ) | &&
| inlinenodiscard

Definition at line 313 of file sstream.

## ◆ str() [2/6]

template<typename _CharT, typename _Traits, typename _Alloc>

__string_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::str | ( |  | ) | const &
| inlinenodiscard

Copying out the string buffer.

Returns
  A copy of one of the underlying sequences.

If the buffer is only created in input mode, the underlying character sequence is equal to the input sequence; otherwise, it is equal to the output sequence. [27.7.1.2]/1

Definition at line 287 of file sstream.

## ◆ str() [3/6]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_stringbuf< _CharT, _Traits, _Alloc >::str | ( | __string_type && | __s | ) |
| inline

Definition at line 371 of file sstream.

## ◆ str() [4/6]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_stringbuf< _CharT, _Traits, _Alloc >::str | ( | const __string_type & | __s | ) |
| inline

Setting a new buffer.

Parameters

  __s | The string to use as a new sequence.

Deallocates any previous stored sequence, then copies s to use as a new one.

Definition at line 349 of file sstream.

## ◆ str() [5/6]

template<typename _CharT, typename _Traits, typename _Alloc>
template<__allocator_like _SAlloc>

basic_string< _CharT, _Traits, _SAlloc > std::basic_stringbuf< _CharT, _Traits, _Alloc >::str | ( | const _SAlloc & | __sa | ) | const
| inlinenodiscard

Definition at line 304 of file sstream.

## ◆ str() [6/6]

template<typename _CharT, typename _Traits, typename _Alloc>
template<__allocator_like _SAlloc>

void std::basic_stringbuf< _CharT, _Traits, _Alloc >::str | ( | const basic_string< _CharT, _Traits, _SAlloc > & | __s | ) |
| inline

Definition at line 363 of file sstream.

## ◆ sungetc()

template<typename _CharT, typename _Traits>

int_type std::basic_streambuf< _CharT, _Traits >::sungetc | ( |  | ) |
| inlineinherited

Moving backwards in the input stream.

Returns
  The previous character, if possible.

If a putback position is available, this function decrements the input pointer and returns that character. Otherwise, calls and returns pbackfail(). The effect is to unget the last character gotten.

Definition at line 406 of file streambuf.

Referenced by std::basic_istream< _CharT, _Traits >::unget().

## ◆ swap() [1/2]

template<typename _CharT, typename _Traits>

void std::basic_streambuf< _CharT, _Traits >::swap | ( | basic_streambuf< _CharT, _Traits > & | __sb | ) |
| inlineprotectedinherited

Definition at line 821 of file streambuf.

## ◆ swap() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc>

void std::basic_stringbuf< _CharT, _Traits, _Alloc >::swap | ( | basic_stringbuf< _CharT, _Traits, _Alloc > & | __rhs | ) |
| inlinenoexcept

Definition at line 263 of file sstream.

## ◆ sync()

template<typename _CharT, typename _Traits>

virtual int std::basic_streambuf< _CharT, _Traits >::sync | ( |  | ) |
| inlineprotectedvirtualinherited

Synchronizes the buffer arrays with the controlled sequences.

Returns
  -1 on failure.

Each derived class provides its own appropriate behavior, including the definition of failure.

Note
  Base class version does nothing, returns zero.

Reimplemented in __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, std::basic_filebuf< char_type, traits_type >, std::basic_filebuf< wchar_t >, and std::wbuffer_convert< _Codecvt, _Elem, _Tr >.

Definition at line 636 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::pubsync().

## ◆ uflow()

template<typename _CharT, typename _Traits>

virtual int_type std::basic_streambuf< _CharT, _Traits >::uflow | ( |  | ) |
| inlineprotectedvirtualinherited

Fetches more data from the controlled sequence.

Returns
  The first character from the pending sequence.

Informally, this function does the same thing as `underflow()`, and in fact is required to call that function. It also returns the new character, like `underflow()` does. However, this function also moves the read position forward by one.

Reimplemented in __gnu_cxx::stdio_sync_filebuf< _CharT, _Traits >.

Definition at line 709 of file streambuf.

Referenced by std::basic_streambuf< char_type, traits_type >::sbumpc(), and xsgetn().

## ◆ underflow()

template<class _CharT, class _Traits, class _Alloc>

basic_stringbuf< _CharT, _Traits, _Alloc >::int_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow | ( |  | ) |
| protectedvirtual

Fetches more data from the controlled sequence.

Returns
  The first character from the pending sequence.

Informally, this function is called when the input buffer is exhausted (or does not exist, as buffering need not actually be done). If a buffer exists, it is refilled. In either case, the next available character is returned, or `traits::eof()` to indicate a null pending sequence.

For a formal definition of the pending sequence, see a good text such as Langer & Kreft, or [27.5.2.4.3]/7-14.

A functioning input streambuf can be created by overriding only this function (no buffer area will be used). For an example, see https://gcc.gnu.org/onlinedocs/libstdc++/manual/streambufs.html

Note
  Base class version does nothing, returns eof().

Reimplemented from std::basic_streambuf< _CharT, _Traits >.

Definition at line 153 of file sstream.tcc.

References _M_mode, std::basic_streambuf< _CharT, _Traits >::egptr(), std::basic_streambuf< _CharT, _Traits >::gptr(), and std::ios_base::in.

## ◆ view()

template<typename _CharT, typename _Traits, typename _Alloc>

basic_string_view< char_type, traits_type > std::basic_stringbuf< _CharT, _Traits, _Alloc >::view | ( |  | ) | const
| inlinenoexcept

Definition at line 332 of file sstream.

## ◆ xsgetn()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::xsgetn | ( | char_type * | __s,
|  | streamsize | __n )
| protectedvirtualinherited

Multiple character extraction.

Parameters

  __s | A buffer area.
  __n | Maximum number of characters to assign.

Returns
  The number of characters assigned.

Fills __s[0] through __s[__n-1] with characters from the input sequence, as if by `sbumpc()`. Stops when either __n characters have been copied, or when `traits::eof()` would be copied.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, and std::basic_filebuf< char_type, traits_type >.

Definition at line 50 of file streambuf.tcc.

References egptr(), gptr(), std::min(), and uflow().

Referenced by std::basic_streambuf< char_type, traits_type >::sgetn().

## ◆ xsputn()

template<typename _CharT, typename _Traits>

streamsize std::basic_streambuf< _CharT, _Traits >::xsputn | ( | const char_type * | __s,
|  | streamsize | __n )
| protectedvirtualinherited

Multiple character insertion.

Parameters

  __s | A buffer area.
  __n | Maximum number of characters to write.

Returns
  The number of characters written.

Writes __s[0] through __s[__n-1] to the output sequence, as if by `sputc()`. Stops when either n characters have been copied, or when `sputc()` would return `traits::eof()`.

It is expected that derived classes provide a more efficient implementation by overriding this definition.

Reimplemented in std::basic_filebuf< _CharT, _Traits >, std::basic_filebuf< _CharT, encoding_char_traits< _CharT > >, std::basic_filebuf< _CharT, std::char_traits< _CharT > >, std::basic_filebuf< char >, and std::basic_filebuf< char_type, traits_type >.

Definition at line 84 of file streambuf.tcc.

References epptr(), std::min(), overflow(), and pptr().

Referenced by std::basic_streambuf< char_type, traits_type >::sputn().

## Member Data Documentation

## ◆ _M_buf_locale

template<typename _CharT, typename _Traits>

locale std::basic_streambuf< _CharT, _Traits >::_M_buf_locale
| protectedinherited

Current locale setting.

Definition at line 201 of file streambuf.

Referenced by std::basic_filebuf< _CharT, _Traits >::basic_filebuf().

## ◆ _M_in_beg

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_beg
| protectedinherited

Start of get area.

Definition at line 193 of file streambuf.

## ◆ _M_in_cur

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_cur
| protectedinherited

Current read area.

Definition at line 194 of file streambuf.

## ◆ _M_in_end

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_in_end
| protectedinherited

End of get area.

Definition at line 195 of file streambuf.

## ◆ _M_mode

template<typename _CharT, typename _Traits, typename _Alloc>

ios_base::openmode std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_mode
| protected

Place to stash in || out || in | out settings for current stringbuf.

Definition at line 114 of file sstream.

Referenced by overflow(), pbackfail(), seekoff(), seekpos(), and underflow().

## ◆ _M_out_beg

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_beg
| protectedinherited

Start of put area.

Definition at line 196 of file streambuf.

## ◆ _M_out_cur

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_cur
| protectedinherited

Current put area.

Definition at line 197 of file streambuf.

## ◆ _M_out_end

template<typename _CharT, typename _Traits>

char_type* std::basic_streambuf< _CharT, _Traits >::_M_out_end
| protectedinherited

End of put area.

Definition at line 198 of file streambuf.

## ◆ _M_string

template<typename _CharT, typename _Traits, typename _Alloc>

__string_type std::basic_stringbuf< _CharT, _Traits, _Alloc >::_M_string
| protected

Definition at line 117 of file sstream.

The documentation for this class was generated from the following files:

- iosfwd
- sstream
- sstream.tcc